package top.daxian1218.dust.edp;

import org.springframework.beans.factory.config.BeanDefinition;
import org.springframework.context.annotation.ClassPathScanningCandidateComponentProvider;
import org.springframework.context.annotation.ImportSelector;
import org.springframework.core.type.AnnotationMetadata;

import java.util.ArrayList;
import java.util.List;
import java.util.Set;

public class EdpImportSelector implements ImportSelector {

    public static final String BASE_PACKAGE = "top.daxian1218.dust.edp";

    @Override
    public String[] selectImports(AnnotationMetadata importingClassMetadata) {

        ClassPathScanningCandidateComponentProvider scanner = new ClassPathScanningCandidateComponentProvider (true);
        Set<BeanDefinition> beanFactorySet = scanner.findCandidateComponents(BASE_PACKAGE);

        List<String> classNames = new ArrayList<>();
        beanFactorySet.forEach(beanDefinition -> classNames.add(beanDefinition.getBeanClassName()));

        return classNames.toArray(new String[0]);
    }
}
