package top.daxian1218.dust.edp.component;

import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Component;
import top.daxian1218.dust.commons.data.HDataRow;
import top.daxian1218.dust.commons.data.HDataTable;
import top.daxian1218.dust.commons.util.TypeUtil;
import top.daxian1218.dust.db.base.IDataAdapter;
import top.daxian1218.dust.db.sql.HSqlCommand;
import top.daxian1218.dust.edp.BuzException;
import top.daxian1218.dust.edp.ui.DictComponent;
import top.daxian1218.dust.edp.ui.MenuStore;

@Component
public class TodoSettingComponent  extends DictComponent {
    @Override
    public Object DoActionAsync(IDataAdapter adapter, String actionCode, MenuStore input) {
        switch (actionCode) {
            case "getMaster": {
                return getObjId(adapter, input.getState().get("menuId"));
            }
        }
        return super.DoActionAsync(adapter, actionCode, input);
    }

    private String getObjId(IDataAdapter adapter, String menuId) {

        HSqlCommand cmd = new HSqlCommand("select du.id, du.frontend_component, du.remark from dict_ui du " +
                "left join sys_menu sm on sm.ui_id = du.id where sm.id=:menuId");
        cmd.setParameter("menuId", TypeUtil.toLong(menuId));
        HDataTable dt = adapter.query(cmd);
        if (dt.isEmpty()) {
            throw new BuzException("无效的菜单");
        }

        HDataRow uiRow = dt.getRows().get(0);
        String frontendComponent = uiRow.getString("frontend_component");
        String uiId = uiRow.getString("id");
        if (StringUtils.equals("PageView", frontendComponent)) {
            // 获取v1界面字典的编码
            HSqlCommand cmdLegacy = new HSqlCommand("select uiobjcode from tfrmuiobj t " +
                    "left join tfrmfuncobj a on t.uiobjcode = a.funcobjcode and a.ismaster='1' " +
                    "left join dict_ui b on b.remark=a.funccode where b.id=:uiId");
            cmdLegacy.setParameter("uiId", TypeUtil.toLong(uiId));

            HDataTable dtObj = adapter.query(cmdLegacy);
            if (dtObj.isEmpty()) {
                throw new BuzException("无效的对象配置");
            }

            return dtObj.get(0).getString("uiobjcode");
        }

        HSqlCommand cmdObj = new HSqlCommand("select duo.obj_id from dict_ui_obj duo where duo.is_master=1 and duo.ui_id=:uiId");
        cmdObj.setParameter("uiId", TypeUtil.toLong(uiId));
        HDataTable dtUIObj = adapter.query(cmdObj);
        if (dtUIObj.isEmpty()) {
            throw new BuzException("无效的对象配置");
        }

        return dtUIObj.get(0).getString("obj_id");
    }
}
