package top.daxian1218.dust.edp.component;

import com.alibaba.fastjson.JSONObject;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Component;
import top.daxian1218.dust.commons.data.HDataTable;
import top.daxian1218.dust.commons.util.TypeUtil;
import top.daxian1218.dust.db.base.IDataAdapter;
import top.daxian1218.dust.db.dict.DictObj;
import top.daxian1218.dust.db.dict.DictObjBuilder;
import top.daxian1218.dust.db.dict.DictObjRow;
import top.daxian1218.dust.db.sql.HSqlCommand;
import top.daxian1218.dust.edp.AppCodes;
import top.daxian1218.dust.edp.BuzException;
import top.daxian1218.dust.edp.DictCodes;
import top.daxian1218.dust.edp.ui.DictComponent;
import top.daxian1218.dust.edp.ui.MenuStore;

@Component
public class UserDictComponent extends DictComponent {

    @Override
    protected void SearchAsync(IDataAdapter adapter, MenuStore store, DictObj obj) {
        if (obj.getCode().equals("MenuObj")) {
            JSONObject state = (JSONObject) obj.getState();
            String uiId = state.getString("uiId");
            if (StringUtils.isEmpty(uiId)) {
                throw new BuzException("界面ID无效");
            }
            DictObj uiObj = DictObjBuilder.create(DictCodes.DictUI, AppCodes.DictApp);
            uiObj.search(TypeUtil.toLong(uiId));
            if (uiObj.isEmpty()) {
                throw new BuzException("界面ID无效");
            }

            DictObjRow row = uiObj.getRow(0);
            String frontendComponent = row.get("frontendComponent").getStringValue();
            String code = row.get("code").getStringValue();
            HSqlCommand cmdQuery = new HSqlCommand();
            if (StringUtils.equals("PageView", frontendComponent)) {
                cmdQuery.appendSql("SELECT '' AS objid, t.FUNCOBJCODE AS code, t2.UIOBJNAME AS name, t.ISMASTER FROM tFrmFuncObj t LEFT JOIN TFRMUIOBJ t2 ON t2.UIOBJCODE =t.FUNCOBJCODE WHERE t.FUNCCODE=:code");
                cmdQuery.setParameter("code", code);
            } else {
                cmdQuery.appendSql("SELECT duo.OBJ_ID AS objid, do.CODE AS code, duo.label AS name, duo.IS_MASTER as ISMASTER FROM DICT_UI_OBJ duo LEFT JOIN DICT_OBJ do ON do.id=duo.OBJ_ID WHERE duo.UI_ID =:id");
                cmdQuery.setParameter("id", TypeUtil.toLong(uiId));
            }

            HDataTable dt = adapter.query(cmdQuery);
            obj.loadData(dt);
            return;
        }

        super.SearchAsync(adapter, store, obj);
    }
}
