package top.daxian1218.dust.edp.controllers;

import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;
import top.daxian1218.dust.db.cache.ICacheManager;

/**
 * @author daxian
 */
@RestController
@RequestMapping(value = "/api/cache", method = RequestMethod.GET)
public class CacheController {

    private final ICacheManager cacheManager;

    public CacheController(ICacheManager cacheManager) {
        this.cacheManager = cacheManager;
    }

    @RequestMapping(value = "flush", method = RequestMethod.GET)
    public Object flushCache() {
        cacheManager.flush(null);
        return true;
    }

    @RequestMapping(value = "flush/{name}", method = RequestMethod.GET)
    public Object flushCache(@PathVariable String name) {
        cacheManager.flush(name);
        return true;
    }

}
