package top.daxian1218.dust.edp.controllers;

import com.alibaba.fastjson.JSONObject;
import org.apache.commons.lang3.StringUtils;
import org.springframework.web.bind.annotation.*;
import top.daxian1218.dust.edp.BuzException;
import top.daxian1218.dust.edp.services.authentication.IUserService;
import top.daxian1218.dust.service.security.SecurityUtils;

@RestController
@RequestMapping("/api")
public class LoginController {
    private final IUserService _userService;

    public LoginController(IUserService userService) {
        _userService = userService;
    }

    @PostMapping("login")
    public JSONObject Login(@RequestBody JSONObject body) {
        JSONObject user = _userService.login(body);
        if (!SecurityUtils.isSuperAdmin() &&
                StringUtils.isEmpty(SecurityUtils.getUserInfo().getRoles())) {
            throw new BuzException("用户未授权", "0008");
        }
        return user;
    }

    @GetMapping("user")
    public JSONObject GetUser() {
        return _userService.getUser();
    }

}