package top.daxian1218.dust.edp.controllers;

import org.springframework.http.HttpHeaders;
import org.springframework.web.bind.annotation.*;
import top.daxian1218.dust.edp.services.storage.StorageService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * @author daxian
 */
@RestController
@RequestMapping("/api/storage")
public class StorageController {
    private final StorageService _storageService;

    public StorageController(StorageService storageService) {
        _storageService = storageService;
    }

    @RequestMapping("file/{id}")
    public Object GetFile(@PathVariable String id, HttpServletResponse response) {
        _storageService.download(id, response);
        return true;
    }

    @PostMapping("file")
    public Object UploadFile(HttpServletRequest request) {
        return _storageService.uploadFiles(request);
    }


    @DeleteMapping("file/{id}")
    public Object DeleteFile(@PathVariable String id) {
        _storageService.delete(id);
        return true;
    }
}