package top.daxian1218.dust.edp.services;

import org.apache.commons.lang3.StringUtils;
import top.daxian1218.dust.commons.util.TypeUtil;
import top.daxian1218.dust.db.DictGlobalConfig;
import top.daxian1218.dust.db.base.IDataAdapter;
import top.daxian1218.dust.service.security.DustUser;
import top.daxian1218.dust.service.security.SecurityUtils;

/**
 * @author daxian
 */
public abstract class BaseService {

    protected DustUser getUser() {
        return SecurityUtils.getUserInfo();
    }

    protected long getUserId() {
        return TypeUtil.toLong(getUser().getId());
    }

    protected boolean isAdmin() {
        return SecurityUtils.isSuperAdmin() && SecurityUtils.isSuperAdmin();
    }

    protected String[] getRoles() {
        DustUser user = getUser();
        if (user == null || StringUtils.isEmpty(user.getRoles())) {
            return new String[0];
        }

        return user.getRoles().split(",");
    }

    protected IDataAdapter getDefaultAdapter() {
        return DictGlobalConfig.Instance.getDataAdapter();
    }
}