package top.daxian1218.dust.edp.services;
import org.springframework.stereotype.Service;
import top.daxian1218.dust.db.dict.DictObj;
import top.daxian1218.dust.db.dict.DictObjBuilder;
import top.daxian1218.dust.db.dict.condition.DictCondition;
import top.daxian1218.dust.db.dict.condition.OperationType;
import top.daxian1218.dust.db.dict.condition.expressions.ColumnExpression;
import top.daxian1218.dust.db.dict.condition.expressions.ValueListExpression;
import top.daxian1218.dust.edp.AppCodes;
import top.daxian1218.dust.edp.DictCodes;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

/**
 * @author daxian
 */
@Service
public class RightService extends BaseService {

    public List<String> getAction(String menuId) {
        DictObj role = DictObjBuilder.create(DictCodes.SysRole, AppCodes.SysApp);

        DictCondition inRoleCode = new DictCondition();
        inRoleCode.setLeft(new ColumnExpression("code"));
        inRoleCode.setOperation(OperationType.IN_LIST);
        inRoleCode.setRight(new ValueListExpression(Arrays.asList(getRoles())));
        role.addCondition(inRoleCode);

        role.search();
        if (role.getRows().isEmpty()) {
            return new ArrayList<>();
        }

        DictObj obj = DictObjBuilder.create(DictCodes.SysRoleAction, AppCodes.SysApp);
        obj.addCondition(new DictCondition("menuId", menuId));

        List<Long> roleIds = role.getRows().stream().map(r -> r.get("id").getLongValue()).collect(Collectors.toList());
        DictCondition inRoleIds = new DictCondition();
        inRoleIds.setLeft(new ColumnExpression("roleId"));
        inRoleIds.setOperation(OperationType.IN_LIST);
        inRoleIds.setRight(new ValueListExpression(roleIds));
        obj.addCondition(inRoleIds);

        obj.search();

        return obj.getRows().stream().map(r -> r.getStringValue("actionId")).distinct().collect(Collectors.toList());
    }
}
