package top.daxian1218.dust.edp.services.dict;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import org.springframework.stereotype.Service;
import top.daxian1218.dust.db.base.IDataAdapter;
import top.daxian1218.dust.db.dict.DictObj;
import top.daxian1218.dust.edp.services.BuzService;
import top.daxian1218.dust.edp.utils.DictObjUtil;

@Service
public class DictSaveDataSetSvc extends BuzService {
    protected boolean DoBeforeSave(JSONObject inParams, DictObj obj, IDataAdapter adapter, boolean batchDelete, JSONObject deleteParams) {
        return true;
    }

    protected boolean DoAfterSave(JSONObject inParams, DictObj obj, IDataAdapter adapter, boolean batchDelete, JSONObject deleteParams) {
        return true;
    }

    public Object InvokeAsync(JSONObject inParams) {
        JSONArray dataSet = inParams.getJSONArray("dataSet");
        if (dataSet == null) {
            return true;
        }

        for (int i = 0; i < dataSet.size(); i++) {
            JSONObject jo = dataSet.getJSONObject(i);
            DictObj obj = DictObjUtil.getDataObj(jo);
            JSONObject deleteParams = jo.getJSONObject("deleteParams");
            if (deleteParams != null) {
                boolean isOk = DoBeforeSave(inParams, obj, getDataAdapter(), true, deleteParams);
                isOk = isOk && DoAfterSave(inParams, obj, getDataAdapter(), true, deleteParams);
                if (!isOk) {
                    return false;
                }
            } else {
                DictObjUtil.LoadData(jo, obj);
                if (DoBeforeSave(inParams, obj, getDataAdapter(), false, new JSONObject())) {
                    obj.save(getDataAdapter());
                    if (!DoAfterSave(inParams, obj, getDataAdapter(), false, new JSONObject())) {
                        return false;
                    }
                } else {
                    return false;
                }
            }
        }

        getDataAdapter().commit();
        return true;
    }
}