package top.daxian1218.dust.edp.services.queryProject;

import top.daxian1218.dust.commons.exception.DustSystemException;

public enum ProjectType {
    /**
     * 预置
     */
    DEV(0),
    /**
     * 个人
     */
    MY(1),
    /**
     * 共享
     */
    SHARED(2);
    private final int value;

    private ProjectType(int type) {
        this.value = type;
    }

    public int getValue() {
        return value;
    }


    public static ProjectType convert(int v) {
        switch (v) {
            case 0:
                return DEV;
            case 1:
                return MY;
            case 2:
                return SHARED;
        }

        throw new DustSystemException("不支持的ProjectType");
    }
}
