package top.daxian1218.dust.edp.services.sys;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import top.daxian1218.dust.edp.BuzException;
import top.daxian1218.dust.edp.services.BaseService;
import top.daxian1218.dust.edp.services.BuzService;
import top.daxian1218.dust.service.repository.MongoRepository;

@Service("my")
public class MyService extends BuzService {

    public static final String USER_MENU_PROFILE = "user_menu_profile";

    private MongoRepository mongoRepository;

    public MyService() {

    }

    @Autowired(required = false)
    public void setMongoRepository(MongoRepository mongoRepository) {
        this.mongoRepository = mongoRepository;
    }

    public JSONObject syncMenuProfile(JSONObject requestParams) {
        String menuId = requestParams.getString("menuId");
        if (StringUtils.isEmpty(menuId)) {
            throw new BuzException("菜单ID无效");
        }

        if (mongoRepository == null) {
            JSONObject result = new JSONObject();
            result.put("enable", false);
            return result;
        }

        requestParams.put("userId", String.valueOf(getUserId()));
        String query = String.format("{ menuId: '%s', userId: '%s' }", menuId, getUserId());
        this.mongoRepository.updateOrInsert(USER_MENU_PROFILE, query, requestParams);
        return new JSONObject();
    }

    public JSONObject getMenuProfile(String id) {
        if (StringUtils.isEmpty(id)) {
            throw new BuzException("菜单ID无效");
        }

        if (mongoRepository == null) {
            JSONObject result = new JSONObject();
            result.put("enable", false);
            return result;
        }

        String query = String.format("{ menuId: '%s', userId: '%s' }", id, getUserId());
        JSONArray data = this.mongoRepository.find(USER_MENU_PROFILE, query);
        return data.size() > 0 ? data.getJSONObject(0) : new JSONObject();
    }

    @Override
    public Object InvokeAsync(JSONObject inParams) {
        String method = inParams.getString("method");
        if (StringUtils.isEmpty(method)) {
            throw new BuzException("method参数无效");
        }

        switch (method) {
            case "syncMenuProfile":
                return syncMenuProfile(inParams.getJSONObject("data"));
            case "getMenuProfile":
                return getMenuProfile(inParams.getString("data"));
            default:
                throw new BuzException("method赞为支持");
        }
    }
}
