package top.daxian1218.dust.edp.ui;

import top.daxian1218.dust.db.base.IDataAdapter;
import top.daxian1218.dust.db.dict.DictObj;
import top.daxian1218.dust.db.dict.condition.DictCondition;

import java.util.List;

/**
 * @author daxian
 */
public interface IBiz {
    boolean BeforeSearchAsync(IDataAdapter adapter, MenuStore dict);

    boolean BeforeDictObjSearchAsync(IDataAdapter adapter, MenuStore dict, DictObj obj);

    void AfterDictObjSearchAsync(IDataAdapter adapter, MenuStore dict, DictObj obj);

    void AfterSearchAsync(IDataAdapter adapter, MenuStore dict);

    boolean BeforeSaveAsync(IDataAdapter adapter, MenuStore dict);

    boolean BeforeDictObjSaveAsync(IDataAdapter adapter, MenuStore dict, DictObj obj);

    void AfterDictObjSaveAsync(IDataAdapter adapter, MenuStore dict, DictObj obj);

    void AfterSaveAsync(IDataAdapter adapter, MenuStore dict);

    void ImportData(IDataAdapter adapter, MenuStore dict, List<DictObj> objList);

    void ExportData(IDataAdapter adapter, MenuStore dict, List<DictObj> objList);

    void HandleDataRightAsync(IDataAdapter adapter, DictObj obj);

    DictCondition GetUserCondition(IDataAdapter adapter, DictObj obj, String columnName, String columnValue);

    /**
     * 保存
     * @param adapter
     * @param menuStore
     * @return
     */
    List<DictObj> Save(IDataAdapter adapter, MenuStore menuStore);

    List<DictObj> SearchAsync(IDataAdapter adapter, MenuStore menuStore);

    Object DoActionAsync(IDataAdapter adapter, String actionCode, MenuStore input);
}
