package top.daxian1218.dust.edp.ui;

import java.util.ArrayList;
import java.util.List;

/**
 * @author daxian
 */
public class UIDict {
    private long id;
    private String menuId;
    private String code;
    private String name;
    private String frontendComponent;
    private String backendComponent;
    private String perms;
    private String remark;
    private final List<UIAction> actions = new ArrayList<>();
    private final List<UIObj> objs = new ArrayList<>();

    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    public String getMenuId() {
        return menuId;
    }

    public void setMenuId(String menuId) {
        this.menuId = menuId;
    }

    public String getBackendComponent() {
        return backendComponent;
    }

    public void setBackendComponent(String backendComponent) {
        this.backendComponent = backendComponent;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getFrontendComponent() {
        return frontendComponent;
    }

    public void setFrontendComponent(String frontendComponent) {
        this.frontendComponent = frontendComponent;
    }

    public String getPerms() {
        return perms;
    }

    public void setPerms(String perms) {
        this.perms = perms;
    }

    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    public List<UIAction> getActions() {
        return actions;
    }

    public List<UIObj> getObjs() {
        return objs;
    }

    public static class UIObj {
        private Long uiId;
        private Long objId;
        private String code;
        private String label;
        private Boolean isDeletable;
        private Boolean isEditable;
        private Boolean isInsertable;
        private Boolean isMaster;
        private Boolean isMultiPage;
        private String parentObj;
        private String masterKey;
        private String detailKey;
        private String fixSearch;
        private String treeField;

        public Long getUiId() {
            return uiId;
        }

        public void setUiId(Long uiId) {
            this.uiId = uiId;
        }

        public Long getObjId() {
            return objId;
        }

        public void setObjId(Long objId) {
            this.objId = objId;
        }

        public String getLabel() {
            return label;
        }

        public void setLabel(String label) {
            this.label = label;
        }

        public Boolean getDeletable() {
            return isDeletable;
        }

        public void setDeletable(Boolean deletable) {
            isDeletable = deletable;
        }

        public Boolean getEditable() {
            return isEditable;
        }

        public void setEditable(Boolean editable) {
            isEditable = editable;
        }

        public Boolean getInsertable() {
            return isInsertable;
        }

        public void setInsertable(Boolean insertable) {
            isInsertable = insertable;
        }

        public Boolean getMaster() {
            return isMaster;
        }

        public void setMaster(Boolean master) {
            isMaster = master;
        }

        public Boolean getMultiPage() {
            return isMultiPage;
        }

        public void setMultiPage(Boolean multiPage) {
            isMultiPage = multiPage;
        }

        public String getParentObj() {
            return parentObj;
        }

        public void setParentObj(String parentObj) {
            this.parentObj = parentObj;
        }

        public String getMasterKey() {
            return masterKey;
        }

        public void setMasterKey(String masterKey) {
            this.masterKey = masterKey;
        }

        public String getDetailKey() {
            return detailKey;
        }

        public void setDetailKey(String detailKey) {
            this.detailKey = detailKey;
        }

        public String getFixSearch() {
            return fixSearch;
        }

        public void setFixSearch(String fixSearch) {
            this.fixSearch = fixSearch;
        }

        public String getTreeField() {
            return treeField;
        }

        public void setTreeField(String treeField) {
            this.treeField = treeField;
        }

        public String getCode() {
            return code;
        }

        public void setCode(String code) {
            this.code = code;
        }
    }

    public static class UIAction {
        private String id;
        private String caption;
        private String code;
        private String actionStyle;
        private String icon;
        private boolean isOnlyIcon;
        private int seqNo;
        private boolean isHidden;
        private String pId;
        private String dispRule;
        private String objCode;

        public String getId() {
            return id;
        }

        public void setId(String id) {
            this.id = id;
        }

        public String getCaption() {
            return caption;
        }

        public void setCaption(String caption) {
            this.caption = caption;
        }

        public String getCode() {
            return code;
        }

        public void setCode(String code) {
            this.code = code;
        }

        public String getActionStyle() {
            return actionStyle;
        }

        public void setActionStyle(String actionStyle) {
            this.actionStyle = actionStyle;
        }

        public String getIcon() {
            return icon;
        }

        public void setIcon(String icon) {
            this.icon = icon;
        }

        public boolean isOnlyIcon() {
            return isOnlyIcon;
        }

        public void setOnlyIcon(boolean onlyIcon) {
            isOnlyIcon = onlyIcon;
        }

        public int getSeqNo() {
            return seqNo;
        }

        public void setSeqNo(int seqNo) {
            this.seqNo = seqNo;
        }

        public boolean isHidden() {
            return isHidden;
        }

        public void setHidden(boolean hidden) {
            isHidden = hidden;
        }

        public String getPId() {
            return pId;
        }

        public void setPId(String pId) {
            this.pId = pId;
        }

        public String getDispRule() {
            return dispRule;
        }

        public void setDispRule(String dispRule) {
            this.dispRule = dispRule;
        }

        public String getObjCode() {
            return objCode;
        }

        public void setObjCode(String objCode) {
            this.objCode = objCode;
        }
    }
}
